Index: /trunk/is_gsdl_cdrom/Component Definitions/Default.cdf
===================================================================
--- /trunk/is_gsdl_cdrom/Component Definitions/Default.cdf	(revision 2877)
+++ /trunk/is_gsdl_cdrom/Component Definitions/Default.cdf	(revision 2878)
@@ -14,5 +14,5 @@
 filegroup0=wordpdf
 COMMENT=
-INCLUDEINBUILD=Yes
+INCLUDEINBUILD=No
 INSTALLATION=ALWAYSOVERWRITE
 COMPRESSIFSEPARATE=No
@@ -139,5 +139,5 @@
 filegroup0=gsarch
 COMMENT=
-INCLUDEINBUILD=Yes
+INCLUDEINBUILD=No
 INSTALLATION=ALWAYSOVERWRITE
 COMPRESSIFSEPARATE=No
@@ -219,5 +219,5 @@
 filegroup0=hdlsub
 COMMENT=
-INCLUDEINBUILD=Yes
+INCLUDEINBUILD=No
 INSTALLATION=ALWAYSOVERWRITE
 COMPRESSIFSEPARATE=No
@@ -244,5 +244,5 @@
 filegroup0=Export collection
 COMMENT=
-INCLUDEINBUILD=Yes
+INCLUDEINBUILD=No
 INSTALLATION=ALWAYSOVERWRITE
 COMPRESSIFSEPARATE=No
@@ -452,5 +452,5 @@
 filegroup0=Not installed files
 COMMENT=
-INCLUDEINBUILD=Yes
+INCLUDEINBUILD=No
 INSTALLATION=ALWAYSOVERWRITE
 COMPRESSIFSEPARATE=No
@@ -505,5 +505,5 @@
 DEFSELECTION=Yes
 COMMENT=
-INCLUDEINBUILD=Yes
+INCLUDEINBUILD=No
 INSTALLATION=ALWAYSOVERWRITE
 COMPRESSIFSEPARATE=No
@@ -530,5 +530,5 @@
 filegroup0=chinese
 COMMENT=
-INCLUDEINBUILD=Yes
+INCLUDEINBUILD=No
 INSTALLATION=ALWAYSOVERWRITE
 COMPRESSIFSEPARATE=No
@@ -555,5 +555,5 @@
 filegroup0=Documentation
 COMMENT=
-INCLUDEINBUILD=Yes
+INCLUDEINBUILD=No
 INSTALLATION=ALWAYSOVERWRITE
 COMPRESSIFSEPARATE=No
Index: /trunk/is_gsdl_cdrom/File Groups/Default.fdf
===================================================================
--- /trunk/is_gsdl_cdrom/File Groups/Default.fdf	(revision 2877)
+++ /trunk/is_gsdl_cdrom/File Groups/Default.fdf	(revision 2878)
@@ -1,3 +1,3 @@
-[gsarch]
+[Local library]
 SELFREGISTERING=No
 HTTPLOCATION=
@@ -16,22 +16,36 @@
 group16=wordpdf
 group17=Documentation
-group0=Local library
-group1=gsarch
-group2=Build-time executables
-group3=hdlsub
-group4=Source files - Windows
-group5=Source files
-group6=Run-time files
-group10=Not installed files - windows
-group7=Web library
+group0=gsarch
+group1=Local library
+group2=hdlsub
+group3=Build-time executables
+group4=Source files
+group5=Source files - Windows
+group6=Web library
+group10=cgi-bin
+group7=Run-time files
 group11=Export collection
 group8=Build-time files
 group12=Empty files - Windows
-group9=cgi-bin
-group13=chinese
-group14=Not installed files
+group9=Not installed files - windows
+group13=Not installed files
+group14=chinese
 group15=Readme
 
-[Local library]
+[gsarch]
+SELFREGISTERING=No
+HTTPLOCATION=
+LANGUAGE=
+OPERATINGSYSTEM=
+FTPLOCATION=
+FILETYPE=No
+INFOTYPE=Standard
+COMMENT=
+COMPRESS=Yes
+COMPRESSDLL=
+POTENTIALLY=No
+MISC=
+
+[Build-time executables]
 SELFREGISTERING=No
 HTTPLOCATION=
@@ -61,5 +75,5 @@
 MISC=
 
-[Build-time executables]
+[Source files - Windows]
 SELFREGISTERING=No
 HTTPLOCATION=
@@ -89,5 +103,5 @@
 MISC=
 
-[Source files - Windows]
+[Run-time files]
 SELFREGISTERING=No
 HTTPLOCATION=
@@ -117,18 +131,4 @@
 MISC=
 
-[Run-time files]
-SELFREGISTERING=No
-HTTPLOCATION=
-LANGUAGE=
-OPERATINGSYSTEM=
-FTPLOCATION=
-FILETYPE=No
-INFOTYPE=Standard
-COMMENT=
-COMPRESS=Yes
-COMPRESSDLL=
-POTENTIALLY=No
-MISC=
-
 [Build-time files]
 SELFREGISTERING=No
@@ -145,19 +145,19 @@
 MISC=
 
+[cgi-bin]
+SELFREGISTERING=No
+HTTPLOCATION=
+LANGUAGE=
+OPERATINGSYSTEM=
+FTPLOCATION=
+FILETYPE=No
+INFOTYPE=Standard
+COMMENT=
+COMPRESS=Yes
+COMPRESSDLL=
+POTENTIALLY=No
+MISC=
+
 [Not installed files - windows]
-SELFREGISTERING=No
-HTTPLOCATION=
-LANGUAGE=
-OPERATINGSYSTEM=
-FTPLOCATION=
-FILETYPE=No
-INFOTYPE=Standard
-COMMENT=
-COMPRESS=Yes
-COMPRESSDLL=
-POTENTIALLY=No
-MISC=
-
-[cgi-bin]
 SELFREGISTERING=No
 HTTPLOCATION=
@@ -206,4 +206,18 @@
 Name=
 
+[chinese]
+SELFREGISTERING=No
+HTTPLOCATION=
+LANGUAGE=
+OPERATINGSYSTEM=
+FTPLOCATION=
+FILETYPE=No
+INFOTYPE=Standard
+COMMENT=
+COMPRESS=Yes
+COMPRESSDLL=
+POTENTIALLY=No
+MISC=
+
 [Not installed files]
 SELFREGISTERING=No
@@ -220,18 +234,4 @@
 MISC=
 
-[chinese]
-SELFREGISTERING=No
-HTTPLOCATION=
-LANGUAGE=
-OPERATINGSYSTEM=
-FTPLOCATION=
-FILETYPE=No
-INFOTYPE=Standard
-COMMENT=
-COMPRESS=Yes
-COMPRESSDLL=
-POTENTIALLY=No
-MISC=
-
 [Readme]
 SELFREGISTERING=No
Index: /trunk/is_gsdl_cdrom/File Groups/Not installed files - windows.fgl
===================================================================
--- /trunk/is_gsdl_cdrom/File Groups/Not installed files - windows.fgl	(revision 2877)
+++ /trunk/is_gsdl_cdrom/File Groups/Not installed files - windows.fgl	(revision 2878)
@@ -1,13 +1,4 @@
-[bin\windows]
-file0=C:\sjboddie\gsdl-2.37-cdrom\Windows\bin\windows\setpw.exe
-fulldirectory=
-
-[bin]
-SubDir0=bin\windows
-fulldirectory=
-
 [TopDir]
 file0=C:\sjboddie\gsdl\src\checkis\checkis_cd\Release\checkis.exe
-SubDir0=bin
 
 [General]
Index: /trunk/is_gsdl_cdrom/File Groups/Run-time files.fgl
===================================================================
--- /trunk/is_gsdl_cdrom/File Groups/Run-time files.fgl	(revision 2877)
+++ /trunk/is_gsdl_cdrom/File Groups/Run-time files.fgl	(revision 2878)
@@ -174,6 +174,11 @@
 file12=C:\sjboddie\gsdl-2.37-cdrom\gsdl\etc\packages\rtftohtm\rtf-ctrl
 
+[bin\windows]
+file0=C:\sjboddie\gsdl-2.37-cdrom\Windows\bin\windows\setpw.exe
+fulldirectory=
+
 [bin]
 SubDir0=bin\java
+SubDir1=bin\windows
 fulldirectory=
 
Index: /trunk/is_gsdl_cdrom/Greenstone Digital Library Software.ipr
===================================================================
--- /trunk/is_gsdl_cdrom/Greenstone Digital Library Software.ipr	(revision 2877)
+++ /trunk/is_gsdl_cdrom/Greenstone Digital Library Software.ipr	(revision 2878)
@@ -6,5 +6,5 @@
 
 [Data]
-CurrentMedia=cdrom
+CurrentMedia=web
 set_mifserial=
 ProductName=Greenstone Digital Library Software
@@ -46,4 +46,5 @@
 [MediaInfo]
 mediadata0=cdrom/Media\cdrom
+mediadata1=web/Media\web
 
 [General]
Index: /trunk/is_gsdl_cdrom/Script Files/setup.rul
===================================================================
--- /trunk/is_gsdl_cdrom/Script Files/setup.rul	(revision 2877)
+++ /trunk/is_gsdl_cdrom/Script Files/setup.rul	(revision 2878)
@@ -1,2 +1,9 @@
+// To create a CDROM distribution, set the bIsCDROM variable to TRUE
+// and set all components "Include in Build" options to "Yes" in the
+// IDE. For a web distribution set bIsCDROM to FALSE and set "Include
+// in Build" to "No" for those components mentioned in the SetComponents()
+// function of this script.
+
+
 
 ////////////////////////////////////////////////////////////////////////////////
@@ -62,4 +69,5 @@
 	prototype DialogSetupType();
 	prototype DialogSelectCollections();
+	prototype DialogAskDestPath();
 	prototype DialogGetAdminPassword();
 	prototype SetComponents();
@@ -85,5 +93,5 @@
 
     // your global variables
-	BOOL bCompact;
+	BOOL bCompact, bIsCDROM;
 	STRING svAdminPassword, svLogFile;
 
@@ -154,5 +162,10 @@
     SetupScreen();
 
-    CheckWin32s();
+	// set this variable to TRUE if we're creating a CDROM installation
+	bIsCDROM = FALSE;
+
+	if (bIsCDROM) then
+    	CheckWin32s();
+    endif;
 
     if (ShowDialogs()<0) goto end_install;
@@ -173,5 +186,7 @@
     CleanUpInstall();
 
-    InstallCollOrganizer();
+	if (bIsCDROM) then
+    	InstallCollOrganizer();
+    endif;
 
     // If an unrecoverable error occurred, clean up
@@ -210,7 +225,11 @@
 		if (nResult = BACK) goto Dlg_SdLicense;
 
-   		Dlg_SetupType:
-   		nResult = DialogSetupType();
-   		if (nResult = BACK) goto Dlg_GreenstoneInstallationType;
+		if (bIsCDROM) then
+   			Dlg_SetupType:
+   			nResult = DialogSetupType();
+   			if (nResult = BACK) goto Dlg_GreenstoneInstallationType;
+   		else
+   			bCompact = TRUE;
+   		endif;
    		
    	else
@@ -224,8 +243,19 @@
    	SetComponents();
    	
-   	Dlg_SelectCollections:
-   	nResult = DialogSelectCollections();
+   	if (bIsCDROM) then
+   	
+   		Dlg_SelectCollections:
+   		nResult = DialogSelectCollections();
+
+   	else
+   	
+   		Dlg_AskDestPath:
+   		nResult = DialogAskDestPath();
+   		
+   	endif;
+   		
    	if (nResult = BACK) then
    		if (bIs32BitSetup = FALSE) goto Dlg_SdLicense;
+		if (bIsCDROM = FALSE) goto Dlg_GreenstoneInstallationType;
    		goto Dlg_SetupType;
    	endif;
@@ -233,5 +263,8 @@
    	Dlg_GetAdminPassWord:
    	nResult = DialogGetAdminPassword();
-   	if (nResult = BACK) goto Dlg_SelectCollections;
+   	if (nResult = BACK) then
+   		if (bIsCDROM) goto Dlg_SelectCollections;
+   		goto Dlg_AskDestPath;
+   	endif;
 
     return 0;
@@ -697,4 +730,16 @@
 
 
+function DialogAskDestPath()
+	NUMBER nResult;
+
+begin
+
+	nResult = SdAskDestPath("", "", svDir, 0);
+	TARGETDIR = svDir;
+	
+	return nResult;
+end;
+
+
 function DialogGetAdminPassword()
 	STRING szTitle, szMsg, szField1;
@@ -733,5 +778,5 @@
 	if (bIs32BitSetup = FALSE) then
 		// Windows 3.1 - make certain no components that may contain
-		// long filenames is selected
+		// long filenames are selected
 		ComponentSelectItem(MEDIA, "Build-time files", FALSE);
 		ComponentSelectItem(MEDIA, "Build-time executables", FALSE);
@@ -745,4 +790,14 @@
 	endif;
 	
+	if (bIsCDROM = FALSE) then
+		// not a CDROM installation - make sure CDROM only components
+		// aren't selected (should also make sure these components have
+		// their "Include in Build" option set to "No" in the IDE)
+		ComponentSelectItem(MEDIA, "Not installed files", FALSE);
+		ComponentSelectItem(MEDIA, "Documentation", FALSE);
+		ComponentSelectItem(MEDIA, "collections", FALSE);
+		ComponentSelectItem(MEDIA, "Export Collection", FALSE);
+	endif;
+	
 end;
 
@@ -755,5 +810,5 @@
 
 	dbfile = TARGETDIR ^ "etc" ^ "users.db";
-	cmd = "\"" + SRCDIR ^ "bin" ^ "windows" ^ "setpw.exe\"";
+	cmd = "\"" + TARGETDIR ^ "bin" ^ "windows" ^ "setpw.exe\"";
 	cmdline = " -u admin -p " + svAdminPassword + " -o \"" + dbfile + "\"";
 
@@ -1134,2 +1189,5 @@
 
 
+
+
+