Index: /trunk/gsdl/src/mgpp/lib/bitio_m_random.cpp
===================================================================
--- /trunk/gsdl/src/mgpp/lib/bitio_m_random.cpp	(revision 2927)
+++ /trunk/gsdl/src/mgpp/lib/bitio_m_random.cpp	(revision 2928)
@@ -68,5 +68,5 @@
   // copy the buffer
   buffer = new u_char [len];
-  //  bcopy ((char *)_rbb.buffer, (char *)buffer, len);
+  //  memcpy (buffer, _rbb.buffer, len);
 memcpy (buffer, _rbb.buffer, len);
   
Index: /trunk/gsdl/src/mgpp/lib/huffman.cpp
===================================================================
--- /trunk/gsdl/src/mgpp/lib/huffman.cpp	(revision 2927)
+++ /trunk/gsdl/src/mgpp/lib/huffman.cpp	(revision 2928)
@@ -52,6 +52,6 @@
       *mem += num * sizeof (char);
     }
-  bcopy ((void *) freqs, (void *) &heap[num], num * sizeof (*heap));
-  bzero ((char *) heap, num * sizeof (*heap));
+  memcpy (&heap[num], freqs, num * sizeof (*heap));
+  memset (heap, '\0', num * sizeof (*heap));
 
   /* Initialise the pointers to the leaves */
@@ -147,5 +147,5 @@
 
   /* zero the lencount's array */
-  bzero ((char *) hd->lencount, sizeof (hd->lencount));
+  memset (hd->lencount, '\0', sizeof (hd->lencount));
   hd->maxcodelen = 0;
   hd->mincodelen = 100;
@@ -203,5 +203,5 @@
   if (mem)
     *mem += data->num_codes * sizeof (*codes);
-  bcopy ((void *) data->min_code, (void *) mc, sizeof (mc));
+  memcpy (mc, data->min_code, sizeof (mc));
   for (i = 0; i < data->num_codes; i++)
     if (data->clens[i])
@@ -230,5 +230,5 @@
     }
 
-  bzero ((char *) values, (MAX_HUFFCODE_LEN + 1) * sizeof (unsigned long *));
+  memset (values, '\0', (MAX_HUFFCODE_LEN + 1) * sizeof (unsigned long *));
 
   if (mem)
@@ -343,5 +343,5 @@
       int i;  /* [RPAP - Jan 97: Endian Ordering] */
 
-      bzero ((char *) (hd->lencount), sizeof (hd->lencount));
+      memset (hd->lencount, '\0', sizeof (hd->lencount));
       if (fread (hd->lencount + hd->mincodelen, sizeof (*hd->lencount),
 	      hd->maxcodelen - hd->mincodelen + 1, f) !=
@@ -356,5 +356,5 @@
 	(*disk) += sizeof (*hd->lencount) * (hd->maxcodelen - hd->mincodelen + 1);
 
-      bzero ((char *) (hd->min_code), sizeof (hd->min_code));
+      memset (hd->min_code, '\0', sizeof (hd->min_code));
 
       if (fread (hd->min_code, sizeof (*hd->min_code), hd->maxcodelen + 1, f) !=
Index: /trunk/gsdl/src/mgpp/lib/local_strings.cpp
===================================================================
--- /trunk/gsdl/src/mgpp/lib/local_strings.cpp	(revision 2927)
+++ /trunk/gsdl/src/mgpp/lib/local_strings.cpp	(revision 2928)
@@ -189,5 +189,5 @@
     return NULL;
 
-  bcopy ((void *) src_str, (void *) (copy), src_str[0] + 1);
+  memcpy (copy, src_str, src_str[0] + 1);
   return copy;
 
@@ -282,5 +282,5 @@
   int i, len = (int) *s++;
 
-  bzero (buf, sizeof (buf));
+  memset (buf, '\0', sizeof(buf));
   for (i = 0; i < len; i++)
     {
Index: /trunk/gsdl/src/mgpp/lib/lovinstem.cpp
===================================================================
--- /trunk/gsdl/src/mgpp/lib/lovinstem.cpp	(revision 2927)
+++ /trunk/gsdl/src/mgpp/lib/lovinstem.cpp	(revision 2928)
@@ -450,5 +450,5 @@
   /* [RPAP - Jan 97: Stem Index Change] */
   u_char copy[MAX_STEM_LENGTH + 2];
-  bcopy ((void *) word, (void *) copy, *word + 1);
+  memcpy (copy, word, *word + 1);
 
   old_length = *copy; /* [RPAP - Jan 97: Stem Index Change] */
@@ -470,5 +470,5 @@
 
   /* [RPAP - Jan 97: Stem Index Change] */
-  bcopy ((void *) copy, (void *) word, *copy + 1);
+  memcpy (word, copy, *copy + 1);
 
 }				/*stem_complex */
Index: /trunk/gsdl/src/mgpp/lib/perf_hash.cpp
===================================================================
--- /trunk/gsdl/src/mgpp/lib/perf_hash.cpp	(revision 2927)
+++ /trunk/gsdl/src/mgpp/lib/perf_hash.cpp	(revision 2928)
@@ -603,5 +603,5 @@
   int i, j;
 
-  bzero ((char *) translate, sizeof (translate));
+  memset (translate, '\0', sizeof (translate));
 
   MAX_L = 1;
@@ -740,5 +740,5 @@
   perf_hash_data *phd;
   translate = (u_char *)Xmalloc (sizeof (u_char) * 256);
-  bzero ((char *) translate, sizeof (u_char) * 256);  /* [RPAP - Feb 97: WIN32 Port] */
+  memset(translate, '\0', sizeof (u_char) * 256);  /* [RPAP - Feb 97: WIN32 Port] */
   make_trans_func (num, keys);
 
Index: /trunk/gsdl/src/mgpp/text/TextGet.cpp
===================================================================
--- /trunk/gsdl/src/mgpp/text/TextGet.cpp	(revision 2927)
+++ /trunk/gsdl/src/mgpp/text/TextGet.cpp	(revision 2928)
@@ -47,5 +47,5 @@
     }
 
-  bzero ((char *) ad, sizeof (*ad));
+  memset (ad, '\0', sizeof (*ad));
 
   for (i = 0; i <= 1; i++)
@@ -144,5 +144,5 @@
     }
 
-  bzero ((char *) num_set, sizeof (num_set));
+  memset (num_set, '\0', sizeof (num_set));
 
   for (i = 0; i < cfh->hd.num_codes; i++)
@@ -232,5 +232,5 @@
   int which;
 
-  bzero ((char *) &cd, sizeof (compression_dict));
+  memset (&cd, '\0', sizeof (compression_dict));
 
   cd.MemForCompDict = sizeof (compression_dict);
Index: /trunk/gsdl/src/mgpp/text/locallib.cpp
===================================================================
--- /trunk/gsdl/src/mgpp/text/locallib.cpp	(revision 2927)
+++ /trunk/gsdl/src/mgpp/text/locallib.cpp	(revision 2928)
@@ -199,5 +199,5 @@
     (*disk) += sizeof (cfh->uncompressed_size);
 
-  bzero ((char *) cfh->huff_words_size, sizeof (cfh->huff_words_size));
+  memset (cfh->huff_words_size, '\0', sizeof (cfh->huff_words_size));
 
   if ((int)fread (cfh->huff_words_size + cfh->hd.mincodelen,
Index: /trunk/gsdl/src/mgpp/text/mgpp_compression_dict.cpp
===================================================================
--- /trunk/gsdl/src/mgpp/text/mgpp_compression_dict.cpp	(revision 2927)
+++ /trunk/gsdl/src/mgpp/text/mgpp_compression_dict.cpp	(revision 2928)
@@ -435,6 +435,6 @@
   escape[0] = 0;
   escape[1] = 0;
-  bzero ((char *) char_freqs, sizeof (char_freqs));
-  bzero ((char *) len_freqs, sizeof (len_freqs));
+  memset (char_freqs, '\0', sizeof (char_freqs));
+  memset (len_freqs, '\0', sizeof (len_freqs));
   for (i = 0; i < num; i++, wd++)
     {
@@ -807,6 +807,6 @@
 
 
-  bzero ((char *) &huff_words_size, sizeof (huff_words_size));
-  bzero ((char *) &lencounts, sizeof (lencounts));
+  memset (&huff_words_size, '\0', sizeof (huff_words_size));
+  memset (&lencounts, '\0', sizeof (lencounts));
 
   mem_reqd = 0;
@@ -873,5 +873,5 @@
   huff_data *hd;
 
-  bzero ((char *) freqs, sizeof (freqs));
+  memset (freqs, '\0', sizeof (freqs));
 
   for (j = 0; j < dd->num_wds; j++, wd++)
@@ -909,5 +909,5 @@
   huff_data *hd;
 
-  bzero ((char *) freqs, sizeof (freqs));
+  memset (freqs, '\0', sizeof (freqs));
 
   for (j = 0; j < dd->num_wds; j++, wd++)
@@ -943,5 +943,5 @@
 		   MAGIC_DICT, MG_ABORT);  /* [RPAP - Feb 97: WIN32 Port] */
 
-  bzero((char *) &cdh, sizeof(cdh));
+  memset (&cdh, '\0', sizeof(cdh));
 
   cdh.dict_type = type;
Index: /trunk/gsdl/src/mgpp/text/mgpp_fast_comp_dict.cpp
===================================================================
--- /trunk/gsdl/src/mgpp/text/mgpp_fast_comp_dict.cpp	(revision 2927)
+++ /trunk/gsdl/src/mgpp/text/mgpp_fast_comp_dict.cpp	(revision 2928)
@@ -489,5 +489,5 @@
     }
 
-  bzero ((char *) num_set, sizeof (num_set));
+  memset (num_set, '\0', sizeof (num_set));
 
   for (i = 0; i < cfh->hd.num_codes; i++)
@@ -550,5 +550,5 @@
 		   sizeof (long *));
 
-  bzero ((char *) values, (MAX_HUFFCODE_LEN + 1) * sizeof (unsigned long *));
+  memset (values, '\0', (MAX_HUFFCODE_LEN + 1) * sizeof (unsigned long *));
 
   if (mem)