Index: trunk/is_gsdl_cdrom/String Tables/Default.shl
===================================================================
--- trunk/is_gsdl_cdrom/String Tables/Default.shl	(revision 2849)
+++ trunk/is_gsdl_cdrom/String Tables/Default.shl	(revision 2933)
@@ -1,15 +1,30 @@
+[TEXT_SERVERTXT_23]
+Comment=
+
+[TEXT_SERVERTXT_12]
+Comment=
+
+[TEXT_SERVERTXT_01]
+Comment=
+
+[TEXT_ADMIN_PW_DESC]
+Comment=
+
 [TEXT_GSARCH]
 Comment=
 
-[TEXT_ADMIN_PW_DESC]
-Comment=
-
-[TEXT_SERVERTXT_01]
-Comment=
-
-[TEXT_SERVERTXT_12]
-Comment=
-
-[TEXT_SERVERTXT_23]
+[TEXT_SERVERTXT_24]
+Comment=
+
+[TEXT_SERVERTXT_13]
+Comment=
+
+[TEXT_SERVERTXT_02]
+Comment=
+
+[TEXT_HDLSUB]
+Comment=
+
+[TITLE_MAIN]
 Comment=
 
@@ -17,17 +32,20 @@
 Comment=
 
-[TITLE_MAIN]
-Comment=
-
-[TEXT_HDLSUB]
-Comment=
-
-[TEXT_SERVERTXT_02]
-Comment=
-
-[TEXT_SERVERTXT_13]
-Comment=
-
-[TEXT_SERVERTXT_24]
+[TEXT_SERVERTXT_25]
+Comment=
+
+[TEXT_SERVERTXT_14]
+Comment=
+
+[TEXT_SERVERTXT_03]
+Comment=
+
+[TEXT_SELECT_COLLECTIONS_DESC]
+Comment=
+
+[LOCAL_LIBRARY_DESC]
+Comment=
+
+[TEXT_UNINSTALL]
 Comment=
 
@@ -35,20 +53,17 @@
 Comment=
 
-[TEXT_UNINSTALL]
-Comment=
-
-[LOCAL_LIBRARY_DESC]
-Comment=
-
-[TEXT_SELECT_COLLECTIONS_DESC]
-Comment=
-
-[TEXT_SERVERTXT_03]
-Comment=
-
-[TEXT_SERVERTXT_14]
-Comment=
-
-[TEXT_SERVERTXT_25]
+[TEXT_SERVERTXT_26]
+Comment=
+
+[TEXT_SERVERTXT_15]
+Comment=
+
+[TEXT_SERVERTXT_04]
+Comment=
+
+[TEXT_SELECT_COLLECTIONS]
+Comment=
+
+[ERROR_COMPONENT]
 Comment=
 
@@ -56,17 +71,14 @@
 Comment=
 
-[ERROR_COMPONENT]
-Comment=
-
-[TEXT_SELECT_COLLECTIONS]
-Comment=
-
-[TEXT_SERVERTXT_04]
-Comment=
-
-[TEXT_SERVERTXT_15]
-Comment=
-
-[TEXT_SERVERTXT_26]
+[TEXT_NOT_ADMIN]
+Comment=
+
+[TEXT_SERVERTXT_16]
+Comment=
+
+[TEXT_SERVERTXT_05]
+Comment=
+
+[COMPANY_NAME16]
 Comment=
 
@@ -74,14 +86,20 @@
 Comment=
 
-[COMPANY_NAME16]
-Comment=
-
-[TEXT_SERVERTXT_05]
-Comment=
-
-[TEXT_SERVERTXT_16]
-Comment=
-
-[TEXT_NOT_ADMIN]
+[TEXT_SERVERTXT_17]
+Comment=
+
+[TEXT_SERVERTXT_06]
+Comment=
+
+[ERROR_FILEGROUP]
+Comment=
+
+[ERROR_MOVEDATA]
+Comment=
+
+[PRODUCT_VERSION]
+Comment=
+
+[SOURCE_CODE]
 Comment=
 
@@ -89,20 +107,5 @@
 Comment=
 
-[SOURCE_CODE]
-Comment=
-
-[PRODUCT_VERSION]
-Comment=
-
-[ERROR_MOVEDATA]
-Comment=
-
-[ERROR_FILEGROUP]
-Comment=
-
-[TEXT_SERVERTXT_06]
-Comment=
-
-[TEXT_SERVERTXT_17]
+[TEXT_SERVERTXT_18]
 Comment=
 
@@ -110,21 +113,35 @@
 Comment=
 
-[TEXT_SERVERTXT_18]
+[TEXT_SERVERTXT_19]
+Comment=
+
+[TEXT_SERVERTXT_08]
+Comment=
+
+[TEXT_FINISH1]
+Comment=
+
+[UNINST_KEY]
 Comment=
 
 [Language]
 Lang0=0009
+Lang1=040c
+Lang2=000a
 CurrentLang=0
 
-[UNINST_KEY]
-Comment=
-
-[TEXT_FINISH1]
-Comment=
-
-[TEXT_SERVERTXT_08]
-Comment=
-
-[TEXT_SERVERTXT_19]
+[TEXT_FINISH2]
+Comment=
+
+[TEXT_SERVERTXT_09]
+Comment=
+
+[TEXT_CHINESE]
+Comment=
+
+[TITLE_CAPTIONBAR]
+Comment=
+
+[WEB_LIBRARY_DESC]
 Comment=
 
@@ -132,107 +149,107 @@
 Comment=
 
-[WEB_LIBRARY_DESC]
-Comment=
-
-[TITLE_CAPTIONBAR]
-Comment=
-
-[TEXT_CHINESE]
-Comment=
-
-[TEXT_SERVERTXT_09]
-Comment=
-
-[TEXT_FINISH2]
-Comment=
-
 [TEXT_FINISH3]
 Comment=
 
+[TEXT_ADMIN_PW]
+Comment=
+
+[TEXT_WORDPDF]
+Comment=
+
+[PRODUCT_NAME16]
+Comment=
+
 [Data]
+Entry29=TEXT_GSARCH
+Entry0=ERROR_VGARESOLUTION
 Entry18=WEB_LIBRARY
-Entry0=ERROR_VGARESOLUTION
-Entry29=TEXT_GSARCH
+Entry1=TITLE_MAIN
 Entry19=WEB_LIBRARY_DESC
-Entry1=TITLE_MAIN
 Entry2=TITLE_CAPTIONBAR
+Entry70=TEXT_FINISH2
 Entry3=UNINST_KEY
-Entry70=TEXT_FINISH2
+Entry71=TEXT_FINISH3
+Entry60=TEXT_SERVERTXT_17
 Entry4=UNINST_DISPLAY_NAME
-Entry60=TEXT_SERVERTXT_17
-Entry71=TEXT_FINISH3
+Entry61=TEXT_SERVERTXT_18
+Entry50=TEXT_SERVERTXT_07
+Entry5=COMPANY_NAME
 Entry72=TEXT_COLLORG
-Entry5=COMPANY_NAME
-Entry50=TEXT_SERVERTXT_07
-Entry61=TEXT_SERVERTXT_18
+Entry73=TEXT_NOT_ADMIN
+Entry62=TEXT_SERVERTXT_19
+Entry51=TEXT_SERVERTXT_08
+Entry6=PRODUCT_NAME
 Entry40=TEXT_ERROR_NO_WIN32S
-Entry6=PRODUCT_NAME
-Entry51=TEXT_SERVERTXT_08
-Entry62=TEXT_SERVERTXT_19
-Entry73=TEXT_NOT_ADMIN
+Entry74=TEXT_SETPW_FAIL
+Entry63=TEXT_SERVERTXT_20
+Entry52=TEXT_SERVERTXT_09
+Entry30=TEXT_WORDPDF
+Entry7=PRODUCT_VERSION
 Entry41=TEXT_ERROR_OLD_WIN32S
-Entry7=PRODUCT_VERSION
-Entry30=TEXT_WORDPDF
-Entry52=TEXT_SERVERTXT_09
-Entry63=TEXT_SERVERTXT_20
-Entry74=TEXT_SETPW_FAIL
+Entry75=TEXT_FILEGREP_FAILED
+Entry64=TEXT_SERVERTXT_21
+Entry53=TEXT_SERVERTXT_10
+Entry31=TEXT_CHINESE
+Entry8=PRODUCT_KEY
+Entry20=SOURCE_CODE
 Entry42=README
-Entry20=SOURCE_CODE
-Entry8=PRODUCT_KEY
-Entry31=TEXT_CHINESE
-Entry53=TEXT_SERVERTXT_10
-Entry64=TEXT_SERVERTXT_21
-Entry75=TEXT_FILEGREP_FAILED
+Entry65=TEXT_SERVERTXT_22
+Entry54=TEXT_SERVERTXT_11
+Entry32=TEXT_HDLSUB
+Entry10=ERROR_UNINSTSETUP
+Entry9=ERROR_MOVEDATA
+Entry21=SOURCE_CODE_DESC
 Entry43=TEXT_UNINSTALL
-Entry21=SOURCE_CODE_DESC
-Entry9=ERROR_MOVEDATA
-Entry10=ERROR_UNINSTSETUP
-Entry32=TEXT_HDLSUB
-Entry54=TEXT_SERVERTXT_11
-Entry65=TEXT_SERVERTXT_22
+Entry66=TEXT_SERVERTXT_23
+Entry55=TEXT_SERVERTXT_12
+Entry44=TEXT_SERVERTXT_01
+Entry33=TEXT_ADMIN_PW
+Entry11=COMPANY_NAME16
 Entry22=TEXT_INSTALL_TYPE
-Entry11=COMPANY_NAME16
-Entry33=TEXT_ADMIN_PW
-Entry44=TEXT_SERVERTXT_01
-Entry55=TEXT_SERVERTXT_12
-Entry66=TEXT_SERVERTXT_23
+Entry67=TEXT_SERVERTXT_24
+Entry56=TEXT_SERVERTXT_13
+Entry45=TEXT_SERVERTXT_02
+Entry34=TEXT_ADMIN_PW_DESC
+Entry12=PRODUCT_NAME16
 Entry23=TEXT_INSTALL_TYPE_DESC
-Entry12=PRODUCT_NAME16
-Entry34=TEXT_ADMIN_PW_DESC
-Entry45=TEXT_SERVERTXT_02
-Entry56=TEXT_SERVERTXT_13
-Entry67=TEXT_SERVERTXT_24
+Entry68=TEXT_SERVERTXT_25
+Entry57=TEXT_SERVERTXT_14
+Entry46=TEXT_SERVERTXT_03
+Entry35=TEXT_PW
+Entry13=ERROR_COMPONENT
 Entry24=TEXT_SETUP_TYPE_DESC
-Entry13=ERROR_COMPONENT
-Entry35=TEXT_PW
-Entry46=TEXT_SERVERTXT_03
-Entry57=TEXT_SERVERTXT_14
-Entry68=TEXT_SERVERTXT_25
+Entry69=TEXT_SERVERTXT_26
+Entry58=TEXT_SERVERTXT_15
+Entry47=TEXT_SERVERTXT_04
+Entry36=TEXT_FINISH1
+Entry14=ERROR_FILEGROUP
 Entry25=TEXT_COMPACT
-Entry14=ERROR_FILEGROUP
-Entry36=TEXT_FINISH1
-Entry47=TEXT_SERVERTXT_04
-Entry58=TEXT_SERVERTXT_15
-Entry69=TEXT_SERVERTXT_26
+Entry59=TEXT_SERVERTXT_16
+Entry48=TEXT_SERVERTXT_05
+Entry37=TEXT_README
+Entry15=ERROR_FILE
 Entry26=TEXT_FULL
-Entry15=ERROR_FILE
-Entry37=TEXT_README
-Entry48=TEXT_SERVERTXT_05
-Entry59=TEXT_SERVERTXT_16
+Entry49=TEXT_SERVERTXT_06
+Entry27=TEXT_SELECT_COLLECTIONS
+Entry16=LOCAL_LIBRARY
 Entry38=FOLDER_NAME
-Entry16=LOCAL_LIBRARY
-Entry27=TEXT_SELECT_COLLECTIONS
-Entry49=TEXT_SERVERTXT_06
+Entry28=TEXT_SELECT_COLLECTIONS_DESC
+Entry17=LOCAL_LIBRARY_DESC
 Entry39=INSTALL_GSDL
-Entry17=LOCAL_LIBRARY_DESC
-Entry28=TEXT_SELECT_COLLECTIONS_DESC
-
-[PRODUCT_NAME16]
-Comment=
-
-[TEXT_WORDPDF]
-Comment=
-
-[TEXT_ADMIN_PW]
+
+[TEXT_PW]
+Comment=
+
+[ERROR_FILE]
+Comment=
+
+[ERROR_VGARESOLUTION]
+Comment=
+
+[WEB_LIBRARY]
+Comment=
+
+[TEXT_SETUP_TYPE_DESC]
 Comment=
 
@@ -240,17 +257,5 @@
 Comment=
 
-[TEXT_SETUP_TYPE_DESC]
-Comment=
-
-[WEB_LIBRARY]
-Comment=
-
-[ERROR_VGARESOLUTION]
-Comment=
-
-[ERROR_FILE]
-Comment=
-
-[TEXT_PW]
+[LOCAL_LIBRARY]
 Comment=
 
@@ -258,5 +263,5 @@
 Comment=
 
-[LOCAL_LIBRARY]
+[TEXT_SETPW_FAIL]
 Comment=
 
@@ -264,5 +269,11 @@
 Comment=
 
-[TEXT_SETPW_FAIL]
+[TEXT_SERVERTXT_20]
+Comment=
+
+[PRODUCT_KEY]
+Comment=
+
+[UNINST_DISPLAY_NAME]
 Comment=
 
@@ -271,11 +282,17 @@
 Version=1.00.000
 
-[UNINST_DISPLAY_NAME]
-Comment=
-
-[PRODUCT_KEY]
-Comment=
-
-[TEXT_SERVERTXT_20]
+[TEXT_SERVERTXT_21]
+Comment=
+
+[TEXT_SERVERTXT_10]
+Comment=
+
+[ERROR_UNINSTSETUP]
+Comment=
+
+[PRODUCT_NAME]
+Comment=
+
+[SOURCE_CODE_DESC]
 Comment=
 
@@ -283,17 +300,14 @@
 Comment=
 
-[SOURCE_CODE_DESC]
-Comment=
-
-[PRODUCT_NAME]
-Comment=
-
-[ERROR_UNINSTSETUP]
-Comment=
-
-[TEXT_SERVERTXT_10]
-Comment=
-
-[TEXT_SERVERTXT_21]
+[TEXT_FILEGREP_FAILED]
+Comment=
+
+[TEXT_SERVERTXT_22]
+Comment=
+
+[TEXT_SERVERTXT_11]
+Comment=
+
+[TEXT_README]
 Comment=
 
@@ -301,14 +315,2 @@
 Comment=
 
-[TEXT_README]
-Comment=
-
-[TEXT_SERVERTXT_11]
-Comment=
-
-[TEXT_SERVERTXT_22]
-Comment=
-
-[TEXT_FILEGREP_FAILED]
-Comment=
-