Index: /trunk/gsdl/macros/english2.dm
===================================================================
--- /trunk/gsdl/macros/english2.dm	(revision 2938)
+++ /trunk/gsdl/macros/english2.dm	(revision 2939)
@@ -941,5 +941,4 @@
 _textlogs_ {Logs}
 _textusagelog_ {usage log}
-_textinitlog_ {init log}
 _texterrorlog_ {error log}
 _textadminhome_ {admin home}
Index: /trunk/gsdl/macros/status.dm
===================================================================
--- /trunk/gsdl/macros/status.dm	(revision 2938)
+++ /trunk/gsdl/macros/status.dm	(revision 2939)
@@ -70,5 +70,4 @@
 <p><b>_textlogs_</b><br>
 <a href="_gwcgi_?e=_compressedoptions_&a=status&p=usagelog" target=infoframe>_textusagelog_</a><br>
-<a href="_gwcgi_?e=_compressedoptions_&a=status&p=initlog" target=infoframe>_textinitlog_</a><br>
 <a href="_gwcgi_?e=_compressedoptions_&a=status&p=errorlog" target=infoframe>_texterrorlog_</a>
 
Index: /trunk/gsdl/src/recpt/cgiwrapper.cpp
===================================================================
--- /trunk/gsdl/src/recpt/cgiwrapper.cpp	(revision 2938)
+++ /trunk/gsdl/src/recpt/cgiwrapper.cpp	(revision 2939)
@@ -193,36 +193,5 @@
   errortext += "correctly.\n";
 
-  text_t init_file = filename_cat (gsdlhome, "etc", "initout.txt");
-  char *ifile = init_file.getcstr();
-  ifstream initin (ifile);
-  delete ifile;
-  if (initin) {
-    errortext += "The initialisation error log, " + init_file + ", contains the\n";
-    errortext += "following information:\n\n";
-    if (!debug) errortext += "<pre>\n";
-
-    char c;
-    initin.get(c);
-    while (!initin.eof ()) {
-      errortext.push_back(c);
-      initin.get(c);
-    }
-    
-    if (!debug) errortext += "</pre>\n";
-
-    initin.close();
-
-  } else {
-    errortext += "Please consult " + init_file + " for more information.\n";
-  }
-
-  format_error_string (errorpage, errortext, debug);
-}
-
-static void page_errorparseargs (const text_t &gsdlhome, bool debug, text_t &errorpage) {
-
-  text_t errortext = "An error occurred during the parsing of the cgi arguments.\n";
-
-  text_t error_file = filename_cat (gsdlhome, "etc", "errout.txt");
+  text_t error_file = filename_cat (gsdlhome, "etc", "error.txt");
   char *efile = error_file.getcstr();
   ifstream errin (efile);
@@ -239,5 +208,7 @@
       errin.get(c);
     }
+    
     if (!debug) errortext += "</pre>\n";
+
     errin.close();
 
@@ -249,9 +220,9 @@
 }
 
-static void page_errorcgipage (const text_t &gsdlhome, bool debug, text_t &errorpage) {
-
-  text_t errortext = "An error occurred during the construction of the cgi page.\n";
-
-  text_t error_file = filename_cat (gsdlhome, "etc", "errout.txt");
+static void page_errorparseargs (const text_t &gsdlhome, bool debug, text_t &errorpage) {
+
+  text_t errortext = "An error occurred during the parsing of the cgi arguments.\n";
+
+  text_t error_file = filename_cat (gsdlhome, "etc", "error.txt");
   char *efile = error_file.getcstr();
   ifstream errin (efile);
@@ -278,4 +249,33 @@
 }
 
+static void page_errorcgipage (const text_t &gsdlhome, bool debug, text_t &errorpage) {
+
+  text_t errortext = "An error occurred during the construction of the cgi page.\n";
+
+  text_t error_file = filename_cat (gsdlhome, "etc", "error.txt");
+  char *efile = error_file.getcstr();
+  ifstream errin (efile);
+  delete efile;
+  if (errin) {
+    errortext += "The error log, " + error_file + ", contains the\n";
+    errortext += "following information:\n\n";
+    if (!debug) errortext += "<pre>\n";
+
+    char c;
+    errin.get(c);
+    while (!errin.eof ()) {
+      errortext.push_back(c);
+      errin.get(c);
+    }
+    if (!debug) errortext += "</pre>\n";
+    errin.close();
+
+  } else {
+    errortext += "Please consult " + error_file + " for more information.\n";
+  }
+
+  format_error_string (errorpage, errortext, debug);
+}
+
 static void print_debug_info (receptionist &recpt) {
 
@@ -289,6 +289,5 @@
        << "Configuration and initialization completed successfully.\n"
        << "  Note that more debug information may be available in the\n"
-       << "  initialization and error logs initout.txt and errout.txt\n"
-       << "  in " << etc_dir << ".\n"
+       << "  initialization and error log error.txt in " << etc_dir << ".\n"
        << "------------------------------------------------------------\n\n";
 
@@ -542,14 +541,14 @@
     }
 
-    text_t init_file = filename_cat (gsdlhome, "etc", "initout.txt");
-    char *iout = init_file.getcstr();
-    ofstream initout (iout);
-    delete iout;
-    if (!recpt.init(initout)) {
+    text_t error_file = filename_cat (gsdlhome, "etc", "error.txt");
+    char *eout = error_file.getcstr();
+    ofstream errout (eout, ios::app);
+    delete eout;
+    if (!recpt.init(errout)) {
       // an error occurred during the initialisation
-      initout.close();
+      errout.close();
       page_errorinit(gsdlhome, debug, errorpage);
     }
-    initout.close();
+    errout.close();
   }
 
@@ -648,5 +647,5 @@
     // output page
     if (errorpage.empty()) {
-      text_t error_file = filename_cat (gsdlhome, "etc", "errout.txt");
+      text_t error_file = filename_cat (gsdlhome, "etc", "error.txt");
       char *eout = error_file.getcstr();
       ofstream errout (eout, ios::app);
Index: /trunk/gsdl/src/recpt/statusaction.cpp
===================================================================
--- /trunk/gsdl/src/recpt/statusaction.cpp	(revision 2938)
+++ /trunk/gsdl/src/recpt/statusaction.cpp	(revision 2939)
@@ -772,52 +772,9 @@
 }
 
-void statusaction::output_initlog (cgiargsclass &/*args*/, displayclass &disp,
-				   outconvertclass &outconvert, 
-				   ostream &textout, ostream &/*logout*/) {
-
-  text_t initfilename = filename_cat (gsdlhome, "etc", "initout.txt");
-  char *cinitfilename = initfilename.getcstr();
-  if (cinitfilename == NULL) return;
-
-  textout << outconvert << disp << "_status:infoheader_(Init log)\n";
-  textout << outconvert << "<h2>Init log</h2>\n";
-
-#ifdef GSDL_USE_IOS_H
-  ifstream initin (cinitfilename, ios::in | ios::nocreate);
-#else
-  ifstream initin (cinitfilename, ios::in);
-#endif
-
-  delete cinitfilename;
-  if (initin) {
-    textout << outconvert << "<p>The initialisation error log, "
-	    << initfilename << ", contains the\n";
-    textout << outconvert << "following information:\n\n";
-    text_t errorpage = "<p><pre>\n";
-    
-    char c;
-    initin.get(c);
-    while (!initin.eof ()) {
-      errorpage.push_back(c);
-      initin.get(c);
-    }
-    
-    errorpage += "</pre>\n";
-    initin.close();
-    textout << outconvert << errorpage;
-    
-  } else {
-    textout << outconvert << "Couldn't read initialisation error log, " 
-	    << initfilename << ".\n";
-  }
-
-  textout << outconvert << disp << "_status:infofooter_\n";
-}
-
 void statusaction::output_errorlog (cgiargsclass &/*args*/, displayclass &disp, 
 				    outconvertclass &outconvert, 
 				    ostream &textout, ostream &logout) {
 
-  text_t errfilename = filename_cat (gsdlhome, "etc", "errout.txt");
+  text_t errfilename = filename_cat (gsdlhome, "etc", "error.txt");
   char *cerrfilename = errfilename.getcstr();
   if (cerrfilename == NULL) return;
@@ -1142,5 +1099,4 @@
   else if (arg_p == "collectioninfo") output_collectioninfo (args, disp, outconvert, textout, logout);
   else if (arg_p == "usagelog") output_usagelog (args, disp, outconvert, textout, logout);
-  else if (arg_p == "initlog") output_initlog (args, disp, outconvert, textout, logout);
   else if (arg_p == "errorlog") output_errorlog (args, disp, outconvert, textout, logout);
   else if (arg_p == "gsdlsite") output_gsdlsite (args, disp, outconvert, textout, logout);
Index: /trunk/gsdl/src/recpt/statusaction.h
===================================================================
--- /trunk/gsdl/src/recpt/statusaction.h	(revision 2938)
+++ /trunk/gsdl/src/recpt/statusaction.h	(revision 2939)
@@ -79,8 +79,4 @@
 			ostream &textout, ostream &logout);
 
-  void output_initlog (cgiargsclass &args, displayclass &disp, 
-		       outconvertclass &outconvert, 
-		       ostream &textout, ostream &logout);
-
   void output_errorlog (cgiargsclass &args, displayclass &disp, 
 			outconvertclass &outconvert, 